//+------------------------------------------------------------------+
//|                                  WPRSI signal V2(SoundAlarm).mq4 |
//|                                                           gumgum |
//|                                           1967policmen@gmail.com |
//+------------------------------------------------------------------+
#property copyright "gumgum"
#property link      "1967policmen@gmail.com"
 
#property  indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Gray
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
#property  indicator_width1  5
//---- input parameters

extern string TimeFrame    = "Current time frame";
extern int    WPRSIperiod  =27;
extern int    Waytoway     =27;
extern int    filterUP     =10;
extern int    filterDN     =10; 
extern bool   UseSound     =false;
extern string SoundFile    ="Alert.wav";
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
//----
double alert; 
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM,0,0);  
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM,0,0);   
   SetIndexBuffer(2, ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM,0,0);   
   SetIndexBuffer(3, ExtMapBuffer4); SetIndexStyle(3,DRAW_ARROW,0,0); SetIndexArrow(3, 233);
   SetIndexBuffer(4, ExtMapBuffer5); SetIndexStyle(4,DRAW_ARROW,0,0); SetIndexArrow(4, 234);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" WPRSI signal v.2("+WPRSIperiod+","+Waytoway+","+filterUP+","+filterDN+")");
   return(0);
}
int deinit() { return(0); }
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
  int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
               int x = iBarShift(NULL,timeFrame,Time[i+1]);               
                  ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",WPRSIperiod,Waytoway,filterUP,filterDN,UseSound,SoundFile,0,y);
                  ExtMapBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",WPRSIperiod,Waytoway,filterUP,filterDN,UseSound,SoundFile,1,y);
                  ExtMapBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"",WPRSIperiod,Waytoway,filterUP,filterDN,UseSound,SoundFile,2,y);
                  if (x==y)
                  {
                     ExtMapBuffer4[i] = EMPTY_VALUE;
                     ExtMapBuffer5[i] = EMPTY_VALUE;
                  }
                  else
                  {
                     ExtMapBuffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"",WPRSIperiod,Waytoway,filterUP,filterDN,UseSound,SoundFile,3,y);
                     ExtMapBuffer5[i] = iCustom(NULL,timeFrame,indicatorFileName,"",WPRSIperiod,Waytoway,filterUP,filterDN,UseSound,SoundFile,4,y);
                  }
            }
            return(0);
         }


   //
   //
   //
   //
   //

   for(i = limit; i >= 0; i--)
   {
      ExtMapBuffer1[i] = EMPTY_VALUE;
      ExtMapBuffer2[i] = EMPTY_VALUE;
      ExtMapBuffer3[i] = EMPTY_VALUE;
      ExtMapBuffer4[i] = EMPTY_VALUE;
      ExtMapBuffer5[i] = EMPTY_VALUE;

      //
      //
      //
      //
      //
      
      double upsum=0;
      int     up1;
      
      if(((iWPR(NULL,0,WPRSIperiod,i)>-50)&&(iRSI(NULL,0,WPRSIperiod,PRICE_MEDIAN,i)<50))||((iWPR(NULL,0,WPRSIperiod,i)<-50)&&(iRSI(NULL,0,WPRSIperiod,PRICE_MEDIAN,i)>50)))
      {
         upsum=0;
         for(up1=0;up1<=Waytoway;up1++)
                  if ((High[i+up1]-Low[i+up1])!= 0) upsum=(Close[i+up1]-Open[i+up1])/(High[i+up1]-Low[i+up1])+upsum;
         ExtMapBuffer1[i]=logic(upsum);
      }
      
      if((iWPR(NULL,0,WPRSIperiod,i)>-50)&&(iRSI(NULL,0,WPRSIperiod,PRICE_MEDIAN,i)>50))
      {
         upsum=0;
         for(up1=0;up1<=Waytoway;up1++)
                  if ((High[i+up1]-Low[i+up1])!= 0) upsum=(Close[i+up1]-Open[i+up1])/(High[i+up1]-Low[i+up1])+upsum;
         ExtMapBuffer2[i]=logic(upsum);
      }

      if( (iWPR(NULL,0,WPRSIperiod,i)>-20)&&(iWPR(NULL,0,WPRSIperiod,i+1)<-20)&&(iRSI(NULL,0,WPRSIperiod,PRICE_MEDIAN,i)>50)           )
      {
         double z=0;
            for(int k=2;k<=filterUP+2;k++) if(iWPR(NULL,0,WPRSIperiod,k+i)>-20) z=1;
            if(z==0)
            {
               upsum=0;
               for(up1=0;up1<=Waytoway;up1++)
                     if ((High[i+up1]-Low[i+up1])!= 0) upsum=(Close[i+up1]-Open[i+up1])/(High[i+up1]-Low[i+up1])+upsum;
               ExtMapBuffer4[i]=logic(upsum);

               if(i==1&&(alert!=Time[1])) if(UseSound) { PlaySound(SoundFile); Alert("Start Long"); }
               alert=Time[1];
            }
      }

      if((iWPR(NULL,0,WPRSIperiod,i)<-50)&&(iRSI(NULL,0,WPRSIperiod,PRICE_MEDIAN,i)<50))
      {
         upsum=0;
         for(up1=0;up1<=Waytoway;up1++)
                  if ((High[i+up1]-Low[i+up1])!=0) upsum=(Close[i+up1]-Open[i+up1])/(High[i+up1]-Low[i+up1])+upsum;
         ExtMapBuffer3[i]=logic(upsum);
      }

      if( (iWPR(NULL,0,WPRSIperiod,i+1)>-80)&&(iWPR(NULL,0,WPRSIperiod,i)<-80)&&(iRSI(NULL,0,WPRSIperiod,PRICE_MEDIAN,i)<50)           )
      {
         double h=0;
         for(int c=2;c<=filterDN+2;c++) if(iWPR(NULL,0,WPRSIperiod,c+i)<-80) h=1;
         if(h==0)
         {
               upsum=0;
               for(up1=0;up1<=Waytoway;up1++)
                        if ((High[i+up1]-Low[i+up1])!=0) upsum=(Close[i+up1]-Open[i+up1])/(High[i+up1]-Low[i+up1])+upsum;
               ExtMapBuffer5[i]=logic(upsum);
               if(i==1&&(alert!=Time[1])) if(UseSound) { PlaySound(SoundFile);Alert("Start Short"); }
               alert=Time[1];
         }
      }         
  }
   return(0);
}

double logic(double cinyan) { if ((MathExp(cinyan)+MathExp(-cinyan))!=0) return((MathExp(cinyan)-MathExp(-cinyan))/(MathExp(cinyan)+MathExp(-cinyan))); return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}